unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, BASSCDRipperDefs, StdCtrls, ComCtrls, BASS, BASSCD, BASSWMA, ShellApi,
  ImgList;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Edit2: TEdit;
    Label2: TLabel;
    GroupBox2: TGroupBox;
    Button1: TButton;
    GroupBox3: TGroupBox;
    Button2: TButton;
    Edit3: TEdit;
    Label3: TLabel;
    Button3: TButton;
    ComboBoxDrives: TComboBoxEx;
    ImageListDrives: TImageList;
    Button4: TButton;
    CheckBox1: TCheckBox;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Edit1: TEdit;
    Label7: TLabel;
    GroupBox4: TGroupBox;
    CheckBox2: TCheckBox;
    GroupBox5: TGroupBox;
    Edit4: TEdit;
    Button5: TButton;
    Label8: TLabel;
    Label9: TLabel;
    Edit5: TEdit;
    GroupBox6: TGroupBox;
    Button6: TButton;
    ComboBoxWMA: TComboBox;
    Button7: TButton;
    CheckBoxVBR: TCheckBox;
    CheckBox4: TCheckBox;
    Labelkbps: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure CheckBoxVBRClick(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure InitBASS;
    procedure EnumarateDrives;
    procedure Error(msg: string);
    procedure ListWMAParams;
  end;

const
  MAXDRIVES = 16;

var
  Form1: TForm1;
  BASSCDRipper: Pointer = nil;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
    if NOT BASSCDRipperDLLLoaded then begin
        Showmessage('Error loading ' + BASSCDRipperDLL + '!');
        Application.Terminate;
    end;
    //* Fill the drive list
    EnumarateDrives;
    //* Initialise BASS
    InitBASS;
    //* Create a ripper object
    BASSCDRipper := BASSCDRipper_Create;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
    //* Free our ripper object
    BASSCDRipper_Free(BASSCDRipper);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
    Close;
end;

procedure TForm1.InitBASS;
begin
	// check the correct BASS was loaded
	if (HIWORD(BASS_GetVersion) <> BASSVERSION) then begin
		MessageBox(0,'An incorrect version of BASS.DLL was loaded',nil,MB_ICONERROR);
		Halt;
	end;

	// Initialize audio - default device, 44100hz, stereo, 16 bits
	if not BASS_Init(-1, 44100, 0, Handle, nil)
        then Error('Error initializing audio!');

    Showmessage('BASS CD Ripper Library uses BASS, BASSCD, BASSEnc, BASSWMA and BASSMix.'
        + (#13#10) + 'You need a separate license to use them in your application.'
        + (#13#10) + 'Available from: http://www.un4seen.com/');
end;

procedure TForm1.EnumarateDrives;
var
  n, tmp: String;
  a: Integer;
  text, DriveStr: String;
  SHFileInfo: TSHFileInfo;
  Icon: TIcon;
  Info: BASS_CD_INFO;
begin
    try
        ComboBoxDrives.Clear;
        ImageListDrives.Clear;
        ImageListDrives.BkColor := clWindow;
        Icon := TIcon.Create;
        // Get list of available drives
        a := 0;
        n := '';
        ZeroMemory(@Info, SizeOf(Info));
        BASS_CD_GetInfo(a, Info);
        tmp := Info.vendor;
        n := n + tmp + ' ';
        tmp := Info.product;
        n := n + tmp;
        while (a < MAXDRIVES) and (n <> '') do begin
            text := Format('%s: %s', [Char(Info.letter + Ord('A')), n]); // "letter: description"
            with ComboBoxDrives.ItemsEx.Add do begin
                Caption := text;
                ImageIndex := a;
            end;
            DriveStr := IncludeTrailingPathDelimiter(Char(Info.letter + Ord('A')) + ':');
            SHGetFileInfo(PChar(DriveStr), 0, SHFileInfo, SizeOf(SHFileInfo), SHGFI_ICON OR SHGFI_SMALLICON);
            Icon.Handle := SHFileInfo.hIcon;
            ImageListDrives.AddIcon(Icon);
            Inc(a);
            n := '';
            ZeroMemory(@Info, SizeOf(Info));
            BASS_CD_GetInfo(a, Info);
            tmp := Info.vendor;
            n := n + tmp + ' ';
            tmp := Info.product;
            n := n + tmp;
            n := Trim(n);
        end;
        if (a = 0)
            then MessageDlg('No optical drives found!', mtError, [mbOK], 0);
        ComboBoxDrives.ItemIndex := 0; // select 1st drive
    finally
        FreeAndNil(Icon);
    end;
end;

procedure TForm1.Error(msg: string);
var
	s: string;
begin
	s := msg + #13#10 + '(Error code: ' + IntToStr(BASS_ErrorGetCode) + ')';
	MessageBox(Handle, PChar(s), nil, 0);
end;

//* Progress callback
procedure OnProgress(BASSCDRipper: Pointer; Progress, TotalProgress: Cardinal); stdcall;
begin
    Form1.Label5.Caption := IntToStr(TotalProgress) + '% - ' + IntToStr(Progress) + '%';
end;

//* WMA OnBefore callback can be used to set meta data
procedure WMAEncBefore(BASSCDRipper: Pointer; WMAEncodingHandle: Cardinal; Track: Integer); stdcall;
begin
    //* See BASSWMA: BASS_WMA_EncodeSetTag() documentation for details
    //* Set Title data
    BASS_WMA_EncodeSetTag(WMAEncodingHandle, PChar('Title'), PChar('Title' + IntToStr(Track)), BASS_WMA_TAG_UNICODE);
    //* Set URL data
    BASS_WMA_EncodeSetTag(WMAEncodingHandle, PChar('WM/PromotionURL'), PChar('http://www.3delite.hu/'), BASS_WMA_TAG_UNICODE);
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  Params: TBASSCDRipperParams;
  i: Integer;
begin
    //* Album mode
    if CheckBox1.Checked then begin
        ZeroMemory(@Params, SizeOf(Params));
        Screen.Cursor := crAppStart;
        Params.Drive := ComboBoxDrives.ItemIndex;
        Params.AlbumMode := CheckBox1.Checked;
        Params.FileName := PChar(Edit2.Text);
        Params.Format := FORMAT_WAV;
        //* Resample
        if CheckBox2.Checked then begin
            Params.Resample := True;
            Params.ResampleFreq := StrToInt(Edit1.Text);
            Params.ResampleChannels := StrToInt(Edit5.Text);
        end;
        BASSCDRipper_SetParams(BASSCDRipper, Params);
        BASSCDRipper_SetProgressCallback(BASSCDRipper, @OnProgress);
        BASSCDRipper_Ripp(BASSCDRipper);
        Screen.Cursor := crDefault;
        if FileExists(Edit2.Text)
            then Showmessage('Completed.');
    //* Multiple tracks mode
    end else begin
        ZeroMemory(@Params, SizeOf(Params));
        Screen.Cursor := crAppStart;
        Params.Drive := ComboBoxDrives.ItemIndex;
        Params.AlbumMode := CheckBox1.Checked;
        Params.FileName := PChar(Edit2.Text);
        Params.Format := FORMAT_WAV;
        //* Resample
        if CheckBox2.Checked then begin
            Params.Resample := True;
            Params.ResampleFreq := StrToInt(Edit1.Text);
            Params.ResampleChannels := StrToInt(Edit5.Text);
        end;
        BASSCDRipper_SetParams(BASSCDRipper, Params);
        BASSCDRipper_SetProgressCallback(BASSCDRipper, @OnProgress);
        //* Fill tracks data
        BASSCDRipper_ClearTracks(BASSCDRipper);
        for i := 0 to BASS_CD_GetTracks(ComboBoxDrives.ItemIndex) - 1 do begin
            BASSCDRipper_AddTracks(BASSCDRipper, PChar(ExtractFilePath(Edit2.Text) + 'Track' + IntToStr(i + 1) + ExtractFileExt(Edit2.Text)));
        end;
        BASSCDRipper_Ripp(BASSCDRipper);
        Screen.Cursor := crDefault;
        Showmessage('Completed.');
    end;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
    BASSCDRipper_StopRipp(BASSCDRipper);
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  Params: TBASSCDRipperParams;
  i: Integer;
begin
    //* Album mode
    if CheckBox1.Checked then begin
        ZeroMemory(@Params, SizeOf(Params));
        Screen.Cursor := crAppStart;
        Params.Drive := ComboBoxDrives.ItemIndex;
        Params.AlbumMode := CheckBox1.Checked;
        Params.FileName := PChar(ChangeFileExt(Edit2.Text, '.flac'));
        Params.Format := FORMAT_ENC;
        //* {o} - will be changed to output file name
        Params.EncCmdLine := PChar(Edit3.Text);
        //* Resample
        if CheckBox2.Checked then begin
            Params.Resample := True;
            Params.ResampleFreq := StrToInt(Edit1.Text);
            Params.ResampleChannels := StrToInt(Edit5.Text);
        end;
        BASSCDRipper_SetParams(BASSCDRipper, Params);
        BASSCDRipper_SetProgressCallback(BASSCDRipper, @OnProgress);
        BASSCDRipper_Ripp(BASSCDRipper);
        Screen.Cursor := crDefault;
    //* Multiple tracks mode
    end else begin
        ZeroMemory(@Params, SizeOf(Params));
        Screen.Cursor := crAppStart;
        Params.Drive := ComboBoxDrives.ItemIndex;
        Params.AlbumMode := CheckBox1.Checked;
        Params.FileName := PChar(ChangeFileExt(Edit2.Text, '.flac'));
        Params.Format := FORMAT_ENC;
        //* {o} - will be changed to output file name
        Params.EncCmdLine := PChar(Edit3.Text);
        Params.EncoderPriority := NORMAL_PRIORITY_CLASS;
        //* Resample
        if CheckBox2.Checked then begin
            Params.Resample := True;
            Params.ResampleFreq := StrToInt(Edit1.Text);
            Params.ResampleChannels := StrToInt(Edit5.Text);
        end;
        BASSCDRipper_SetParams(BASSCDRipper, Params);
        BASSCDRipper_SetProgressCallback(BASSCDRipper, @OnProgress);
        //* Fill tracks data
        BASSCDRipper_ClearTracks(BASSCDRipper);
        for i := 0 to BASS_CD_GetTracks(ComboBoxDrives.ItemIndex) - 1 do begin
            BASSCDRipper_AddTracks(BASSCDRipper, PChar(ExtractFilePath(Edit2.Text) + 'Track' + IntToStr(i + 1) + '.flac'));
        end;
        BASSCDRipper_Ripp(BASSCDRipper);
        Screen.Cursor := crDefault;
    end;
end;

procedure TForm1.Button5Click(Sender: TObject);
var
  Params: TBASSCDRipperParams;
begin
    //* Ripp single track in WAV mode
    ZeroMemory(@Params, SizeOf(Params));
    Screen.Cursor := crAppStart;
    Params.Drive := ComboBoxDrives.ItemIndex;
    Params.Format := FORMAT_WAV;
    //* Resample
    if CheckBox2.Checked then begin
        Params.Resample := True;
        Params.ResampleFreq := StrToInt(Edit1.Text);
        Params.ResampleChannels := StrToInt(Edit5.Text);
    end;
    BASSCDRipper_SetParams(BASSCDRipper, Params);
    BASSCDRipper_SetProgressCallback(BASSCDRipper, @OnProgress);
    BASSCDRipper_RippTrack(BASSCDRipper, StrToInt(Edit4.Text), PChar(Edit2.Text));
    Screen.Cursor := crDefault;
    if FileExists(Edit2.Text)
        then Showmessage('Completed.');

    //* Ripp single track with encoder
    (*
    ZeroMemory(@Params, SizeOf(Params));
    Screen.Cursor := crAppStart;
    Params.Drive := ComboBoxDrives.ItemIndex;
    Params.Format := FORMAT_ENC;
    //* {o} - will be changed to output file name
    Params.EncCmdLine := PChar(Edit3.Text);
    //* Resample
    if CheckBox2.Checked then begin
        Params.Resample := True;
        Params.ResampleFreq := StrToInt(Edit1.Text);
        Params.ResampleChannels := 2;
    end;
    BASSCDRipper_SetParams(BASSCDRipper, Params);
    BASSCDRipper_SetProgressCallback(BASSCDRipper, @OnProgress);
    BASSCDRipper_RippTrack(BASSCDRipper, StrToInt(Edit4.Text), PChar(ChangeFileExt(Edit2.Text, '.flac')));
    Screen.Cursor := crDefault;
    *)

    //* Ripp single track in WMA mode
    (*
    ZeroMemory(@Params, SizeOf(Params));
    Screen.Cursor := crAppStart;
    Params.Drive := ComboBoxDrives.ItemIndex;
    Params.Format := FORMAT_WMA;
    if CheckBoxVBR.Checked
        then Params.WMAQuality := StrToInt(ComboBoxWMA.Text)
        else Params.WMAQuality := StrToInt(ComboBoxWMA.Text) * 1000;
    //* See BASSWMA: BASS_WMA_EncodeOpenFile() Flags for details
    if CheckBox4.Checked
        then Params.WMAEncFlags := BASS_WMA_ENCODE_PRO;
    //* Resample
    if CheckBox2.Checked then begin
        Params.Resample := True;
        Params.ResampleFreq := StrToInt(Edit1.Text);
        Params.ResampleChannels := StrToInt(Edit5.Text);
    end;
    BASSCDRipper_SetParams(BASSCDRipper, Params);
    BASSCDRipper_SetProgressCallback(BASSCDRipper, @OnProgress);
    BASSCDRipper_RippTrack(BASSCDRipper, StrToInt(Edit4.Text), PChar(Edit2.Text));
    Screen.Cursor := crDefault;
    if FileExists(Edit2.Text)
        then Showmessage('Completed.');
    *)
end;

procedure TForm1.ListWMAParams;
var
  Rates: PDWord;
  Flags: Cardinal;
  Freq: Integer;
  Channels: Integer;
begin

    ComboBoxWMA.Clear;

    if CheckBoxVBR.Checked then begin
        Flags := BASS_WMA_ENCODE_RATES_VBR;
        Labelkbps.Caption := '%';
    end else begin
        Flags := 0;
        Labelkbps.Caption := 'kbps';
    end;

    if CheckBox2.Checked then begin
        Freq := StrToInt(Edit1.Text);
        Channels := StrToInt(Edit5.Text);
    end else begin
        Freq := 44100;
        Channels := 2;
    end;

    if CheckBox4.Checked then begin
        Flags := Flags OR BASS_WMA_ENCODE_PRO;
    end;

    Rates := BASS_WMA_EncodeGetRates(Freq, Channels, Flags);

    if (Rates = nil) then begin
        MessageDlg('Can''t find codec or unsupported parameters!', mtError, [mbOk], 0);
        ComboBoxWMA.Text := 'Error';
        ComboBoxWMA.Enabled := False;
        Exit;
    end else begin
        ComboBoxWMA.Enabled := True;
        ComboBoxWMA.Text := 'Select...';
        while (Rates^ <> 0) do begin
            if (Flags AND BASS_WMA_ENCODE_RATES_VBR) > 0
                then ComboBoxWMA.Items.Add(IntToStr(Rates^))
                else ComboBoxWMA.Items.Add(IntToStr(Rates^ div 1000));
            Inc(Rates);
        end;
    end;

end;

procedure TForm1.Button6Click(Sender: TObject);
begin
    ListWMAParams;
end;

procedure TForm1.CheckBoxVBRClick(Sender: TObject);
begin
    ListWMAParams;
end;

procedure TForm1.CheckBox4Click(Sender: TObject);
begin
    ListWMAParams;
end;

procedure TForm1.Button7Click(Sender: TObject);
var
  Params: TBASSCDRipperParams;
  i: Integer;
begin
    //* Album mode
    if CheckBox1.Checked then begin
        ZeroMemory(@Params, SizeOf(Params));
        Screen.Cursor := crAppStart;
        Params.Drive := ComboBoxDrives.ItemIndex;
        Params.AlbumMode := CheckBox1.Checked;
        Params.FileName := PChar(ChangeFileExt(Edit2.Text, '.wma'));
        Params.Format := FORMAT_WMA;
        if CheckBoxVBR.Checked
            then Params.WMAQuality := StrToInt(ComboBoxWMA.Text)
            else Params.WMAQuality := StrToInt(ComboBoxWMA.Text) * 1000;
        //* See BASSWMA: BASS_WMA_EncodeOpenFile() Flags for details
        if CheckBox4.Checked
            then Params.WMAEncFlags := BASS_WMA_ENCODE_PRO;
        //* Set a callback to set meta data
        BASSCDRipper_SetWMAEncCallback(BASSCDRipper, @WMAEncBefore);
        //* Resample
        if CheckBox2.Checked then begin
            Params.Resample := True;
            Params.ResampleFreq := StrToInt(Edit1.Text);
            Params.ResampleChannels := StrToInt(Edit5.Text);
        end;
        BASSCDRipper_SetParams(BASSCDRipper, Params);
        BASSCDRipper_SetProgressCallback(BASSCDRipper, @OnProgress);
        BASSCDRipper_Ripp(BASSCDRipper);
        Screen.Cursor := crDefault;
        if FileExists(Edit2.Text)
            then Showmessage('Completed.');
    //* Multiple tracks mode
    end else begin
        ZeroMemory(@Params, SizeOf(Params));
        Screen.Cursor := crAppStart;
        Params.Drive := ComboBoxDrives.ItemIndex;
        Params.AlbumMode := CheckBox1.Checked;
        Params.FileName := PChar(ChangeFileExt(Edit2.Text, '.wma'));
        Params.Format := FORMAT_WMA;
        if CheckBoxVBR.Checked
            then Params.WMAQuality := StrToInt(ComboBoxWMA.Text)
            else Params.WMAQuality := StrToInt(ComboBoxWMA.Text) * 1000;
        if CheckBox4.Checked
            then Params.WMAEncFlags := BASS_WMA_ENCODE_PRO;
        //* Set a callback to set meta data
        BASSCDRipper_SetWMAEncCallback(BASSCDRipper, @WMAEncBefore);                    
        //* Resample
        if CheckBox2.Checked then begin
            Params.Resample := True;
            Params.ResampleFreq := StrToInt(Edit1.Text);
            Params.ResampleChannels := StrToInt(Edit5.Text);
        end;
        BASSCDRipper_SetParams(BASSCDRipper, Params);
        BASSCDRipper_SetProgressCallback(BASSCDRipper, @OnProgress);
        //* Fill tracks data
        BASSCDRipper_ClearTracks(BASSCDRipper);
        for i := 0 to BASS_CD_GetTracks(ComboBoxDrives.ItemIndex) - 1 do begin
            BASSCDRipper_AddTracks(BASSCDRipper, PChar(ExtractFilePath(Edit2.Text) + 'Track' + IntToStr(i + 1) + '.wma'));
        end;
        BASSCDRipper_Ripp(BASSCDRipper);
        Screen.Cursor := crDefault;
        Showmessage('Completed.');
    end;

end;

end.
